'use strict';

var domain = require('domain');

function createDomain(name, req, res){
    var d = domain.createDomain();
    d.name = name;
    if(req != null){
        d.add(req);
    }
    d.add(res);
    d.on('error', function(err){
        try {
            res.writeHeader(500, {'Content-Type' : "text/html"});
            res.write("<h1>" + err.name + "</h1>");
            res.end("<p style='border:1px dotted red;'>" +" Error occurred in " + process.domain.name + " Error Message : "+ err.message + "</p>");
            console.error("Inside " + process.domain.name + " Error : " + err.message);
            showStack('After Error');
        } catch (err) {
            console.error('Error sending 500 in ' + process.domain.name + ' Error : ', err, req.url);
        }
         d.dispose();
    });
    return d;
}

function showStack(label){
    console.log(label + " Domain Stack : ");
    console.log(domain._stack);
}

module.exports.createDomain = createDomain;
module.exports.showStack = showStack;